Net::Socket@ sock;
bool sockIsConnected = false;
bool canNotConnect = false;
bool initSocketConnection()
{
	// Create a new socket.
	@sock = Net::Socket();

	if (!sock.Connect("willers.digital", 3201)) {
		// If it failed, there was some socket error. (This is not necessarily
		// a connection error!)
		print("Couldn't initiate socket connection.");
		canNotConnect = true;
		return false;
	}
	// Wait until we are connected. This is indicated by whether we can write
	// to the socket.
	startnew(checkIfCanWrite);
	while (!sock.CanWrite()) {
		yield();
	}
	canNotConnect = false;
	sockIsConnected = true;
	startnew(waitingForResponse);
	sleep(500);
	return true;
}

void checkIfCanWrite() {
	sleep(3000);
	if (!sockIsConnected) {
		canNotConnect = true;
	}
}

void waitingForResponse() {

	while (true) {
        string line;
        if (sock.ReadLine(line)) {
            auto js = Json::Parse(line);
            handleMessage(js);
        }
        yield();
    }
}

void requestSocketServer(const Json::Value &in js) {
	//print("JSON REQ: " + Json::Write(js));
	// Send raw data (as a string) to the server.
	if (!sock.WriteRaw(Json::Write(js))) {
		// If this fails, the socket might not be open. Something is wrong!
		print("Couldn't send data.");
		return;
	}
}

void handleMessage(const Json::Value &in js)
{
	//print("JSON RES: " + Json::Write(js));
	if (Json::Write(js) != "null") {
		setVotingInformation(js);
	} 
}

void closeSocket() {
	sock.Close();
	sockIsConnected = false;
}
